-------------------------------------------------------------------------
-- Project: JCPU, a portable 8-bit RISC CPU written in VHDL
-- This file: cpu_embedded using cpu_core and rom
--
-- Copyright (C) 2007 J. Ahrensfeld
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- For questions and ideas, please contact the author at jens@jayfield.org
--
--------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;

entity tb_juart_tx is
end;

architecture behave of tb_juart_tx is

	-- Number of user data words for simulation
	constant CLK_PERIOD		: time := 10 ns;
	constant BAUD_DIV		: natural := 2;

	signal rst				: std_logic := '1';  
	signal clk				: std_logic := '1';  
	signal en_16_x_baud		: std_logic := '1';  
	signal we				: std_logic := '0';  
	signal ser_out			: std_logic;  
	signal Tx_complete		: std_logic;  
	signal din				: unsigned(7 downto 0) := (others => '0');

	signal baud_count		: unsigned(15 downto 0);
	signal baud_reg			: unsigned(15 downto 0) := to_unsigned(BAUD_DIV-1, baud_count'length);
begin

dut : entity work.juart_tx
	PORT MAP
	(
		rst					=> rst,
		clk					=> clk,
		we					=> we,
		din					=> din,
		en_16_x_baud		=> en_16_x_baud,
		Tx_complete			=> Tx_complete,
		ser_out				=> ser_out
	);


CLK_GEN: process
	begin
		wait for CLK_PERIOD/2;
		clk <= not clk;
	end process;

baud_timer:
process(clk)
begin
	if rising_edge(clk) then
		en_16_x_baud <= '0';
		if rst = '1' then
			baud_count <= (others => '0');
		elsif baud_count = baud_reg then
			baud_count <= (others => '0');
			en_16_x_baud <= '1';
		else
			baud_count <= baud_count + 1;
		end if;
	end if;
end process;

------------------------------------------------------------------------------------------

STIMULUS: process


	begin

		wait for 3*CLK_PERIOD;
		rst <= '0';
		wait for 3*CLK_PERIOD;
		wait until rising_edge(clk);
		din <= X"A5";
		wait until rising_edge(clk) and Tx_complete = '1';
		we <= '1';
		wait until rising_edge(clk) and Tx_complete = '0';
		we <= '0';
		wait until rising_edge(clk) and Tx_complete = '1';
		din <= X"AA";
		wait until rising_edge(clk) and Tx_complete = '1';
		we <= '1';
		wait until rising_edge(clk) and Tx_complete = '0';
		we <= '0';
		din <= X"55";
		wait until rising_edge(clk) and Tx_complete = '1';
		we <= '1';
		wait until rising_edge(clk) and Tx_complete = '0';
		we <= '0';
		wait; 
	
	end process;
	
end architecture behave;
